import { PaginationUtils } from '../../../../../utils/outerTableComponents/pagination/paginationUtils';
import { LoadingElement } from '../../../../../utils/outerTableComponents/loading/loadingElement';
import { UpdateIndexColumnWidth } from '../../../../indexColumn/updateIndexColumnWidth';
import { MoveUtils } from '../../../../../utils/moveStructure/moveUtils';
import { PageButtonStyle } from '../../pageButtonStyle';
export class PageNumberButtonEvents {
    // REF-30
    static markClick(pagination) {
        pagination.clickedPageNumberButton = true;
        setTimeout(() => (pagination.clickedPageNumberButton = false));
    }
    static async loadPaginationAsync(at, buttonNumber) {
        var _a;
        // should still allow custom loading
        if (at._activeOverlayElements.loading) {
            LoadingElement.update(at._activeOverlayElements.loading, at.tableStyle);
            (_a = at._tableElementRef) === null || _a === void 0 ? void 0 : _a.appendChild(at._activeOverlayElements.loading);
        }
        await new Promise((resolve) => {
            setTimeout(() => {
                var _a;
                // this.updateCell({
                //   newText: '2',
                //   columnIndex: 2,
                //   rowIndex: 15,
                // });
                // columnDetails.elements[targetIndex]
                const delta = at.dataStartsAtHeader ? 0 : 1;
                const startIndex = (buttonNumber - 1) * 10 + delta;
                at._columnsDetails.forEach((columnDetails, columnIndex) => {
                    for (let i = 0; i < 10; i += 1) {
                        const rowIndex = startIndex + i;
                        MoveUtils.setNewElementText2(at, 'Earth', columnDetails.elements[rowIndex], columnIndex, rowIndex);
                    }
                });
                UpdateIndexColumnWidth.update(at);
                // InsertNewRow.insert(this, 15, false, ['Earth', 12756, 5.97, 1, 5514]);
                // RemoveRow.removeRow(this, this.data.length - 1);
                // this.updateStructure({data: ['Earth', 12756, 5.97, 1, 5514], index: 10, isInsert: true, structure: 'row'});
                setTimeout(() => {
                    // PageButtonElement.setActive(this, buttonNumber);
                    // NumberOfVisibleRowsElement.update(this);
                }, 10);
                (_a = at._activeOverlayElements.loading) === null || _a === void 0 ? void 0 : _a.remove();
                // at._tableElementRef?.removeChild(element);
                PaginationUtils.displayRowsForDifferentButton(at, buttonNumber);
                resolve();
            }, 2000);
        });
    }
    static async buttonMouseUp(buttonNumber, event) {
        PageNumberButtonEvents.markClick(this._pagination);
        const buttonElement = event.target;
        const { pageButtons } = this._pagination.styles;
        if (this._pagination.activePageNumber === buttonNumber) {
            PageButtonStyle.mouseEnter(buttonElement, pageButtons, false);
        }
        else {
            if (this._pagination._async) {
                PageNumberButtonEvents.loadPaginationAsync(this, buttonNumber);
            }
            else {
                PaginationUtils.displayRowsForDifferentButton(this, buttonNumber);
            }
            // for the case when mouse clicks on a number button and no new buttons are created
            PageButtonStyle.mouseEnter(buttonElement, pageButtons, false);
        }
    }
    static setEvents(at, buttonNumber, buttonElement) {
        buttonElement.onmouseup = PageNumberButtonEvents.buttonMouseUp.bind(at, buttonNumber);
    }
}
//# sourceMappingURL=pageNumberButtonEvents.js.map